﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Reflection;
using System.Runtime.Serialization.Formatters.Binary;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace WindowsFormsApplication115
{
    public partial class Form1 : Form
    {
        StudentV3 sv3;
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            StudentV1 sv1 = new StudentV1();
            sv1.AM = "p17123";
            sv1.Name = "George";
            sv1.email = "geo@unipi.gr";
            sv1.age = 20;
        }

        private void button2_Click(object sender, EventArgs e)
        {
            StudentV2 sv2 = new StudentV2();
            sv2.AM = "p17231";
            sv2.Name = "Maria";
            sv2.email = "mar2@unipi.gr";
            sv2.age = 21;
        }

        private void button3_Click(object sender, EventArgs e)
        {
            sv3 = new StudentV3()
                .addAM("p17321")
                .addName("Christos")
                .addemail("chris@gmail.com")
                .addage(19);   //method chaining



            //Bonus Reflection Magic 
            PropertyInfo[] pInfoArray = sv3.GetType().GetProperties();
            String s = "";
            foreach(var v in pInfoArray)
            {
                s += v.GetValue(sv3).ToString() + Environment.NewLine;
            }
            MessageBox.Show(s);
        }

        private void button4_Click(object sender, EventArgs e)
        {
            BinaryFormatter bf = new BinaryFormatter();
            Stream st = new FileStream("sv3.txt", FileMode.OpenOrCreate);
            bf.Serialize(st, sv3);
            st.Close();
        }

        private void button5_Click(object sender, EventArgs e)
        {
            BinaryFormatter bf = new BinaryFormatter();
            Stream st = new FileStream("sv3.txt", FileMode.OpenOrCreate);
            StudentV3 s = (StudentV3)bf.Deserialize(st);
            MessageBox.Show(s.Name);
            st.Close();
        }

        private void button6_Click(object sender, EventArgs e)
        {
            String dir = Application.StartupPath+"\\data";
            String[] myFiles = Directory.GetFiles(dir, "*.txt");
            foreach (String s in myFiles)
                richTextBox1.AppendText(Path.GetFileName(s) + Environment.NewLine);
        }
    }
}
